#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>

/**
 * Generates a backup config with the
 * specified key and SSID
 *
 */


int main (int argc, char **argv)
{
	if (argc < 4)
	{
	 	fprintf (stderr, "Usage: genconfig Input_Config Wifi_SSID Wifi_WPA_Key\n");
		return 1;
	}
	
	FILE *inputFp = fopen (argv[1], "r");

	if (!inputFp)
	{
		fprintf (stderr, "cannot open file `%s'", argv[1]);
		return 2;
	}

	int c;
	int inTag = 0;
	char tagName[400];
	int inPriWlan = 0;
	int l;

	int i = 0;
	while ((c = getc (inputFp)) != EOF)
	{
		printf("%c", c);

		if (c == '<')
		{
			// Hit start of tag
			inTag = 1;
		}
		else if (c == '>')
		{
			inTag = 0;
			i = 0;

			if (strcmp(tagName, "WlVirtIntfCfg instance=\"1\"") == 0)
			{
				inPriWlan = 1;
			}
			if (strcmp(tagName, "/WlVirtIntfCfg") == 0)
			{
				inPriWlan = 0;
			}

			if (strcmp(tagName, "WlSsid") == 0 && inPriWlan)
			{
				printf("%s", argv[2]);
			}

			if (strcmp(tagName, "WlWpaPsk") == 0 && inPriWlan)
			{
				printf("%s", argv[3]);
			}
		}
		else if (inTag)
		{
			if (i < 400)
			{
				tagName[i] = c;
				tagName[i + 1] = 0;
				i++;
			}
			else
			{
				fprintf (stderr, "Tag name too big!\n");
				return 3;
			}
		}
	}
	
}
