#!/bin/sh

if [ $# -lt 2 ]; then
	echo "Usage: $0 Wifi_SSID Wifi_WPA_Key LAN_MAC"
	echo ""
	echo "All these are found on the label on the base of the router"
	echo ""
	echo "Example: $0 SKY13234 ABCDE 00:11:22:33:44:55"
	exit 1
fi

echo "Creating config file (/tmp/sky.cfg)."
genconfig /etc/base_cfg.xml $1 $2 > /tmp/sky.cfg

echo "Writing backup-config partition."
fast backup-config write -p Fast.CPE < /tmp/sky.cfg
 
echo "Writing psi-config partition."
fast psi-config write -p Fast.CPE < /tmp/sky.cfg

if [ $# -eq 3 ]; then
	echo "Writing base mac address. ($3)"
	echo "$3" | fast base-mac write -p Fast.CPE
fi

echo "Rebooting..."
reboot
