#! /bin/sh

tools_dir='tools'
input_dir='input'
output_dir='output'

BRCM_CHIP="6362"
BRCM_BOARD_ID="F@ST2504n"
BRCM_FLASHBLK_SIZE=64
BRCM_NUM_MAC_ADDRESSES=11
BRCM_BASE_MAC_ADDRESS="00:1b:bf:c1:0a:ed"
BRCM_PSI_SIZE=24
BRCM_MAIN_TP_NUM=0

rm -R $output_dir/*

echo ""
echo "==Extract original filesystem=="
./extract_filesystem.sh

echo ""
echo "==Apply changes=="
cp -RP ./changes/* ./target/

echo ""
echo "==Create filesystem image=="
./create_filesystem.sh

echo ""
echo "==Build fs_kernel broadcom (recovery) image=="
tools/bcmImageBuilder --output $output_dir/bcm963xx_fs_kernel --chip $BRCM_CHIP --board $BRCM_BOARD_ID --blocksize 64 --rootfsfile $output_dir/rootfs.sfs --kernelfile $input_dir/vmlinux.lz --cfefile  $input_dir/cfe.bin

echo ""
echo "==Build cfe_fs_kernel broadcom (recovery) image=="
tools/bcmImageBuilder --output $output_dir/bcm963xx_cfe_fs_kernel --chip $BRCM_CHIP --board $BRCM_BOARD_ID --blocksize $BRCM_FLASHBLK_SIZE --cfefile $input_dir/cfe.bin --rootfsfile $output_dir/rootfs.sfs --kernelfile $input_dir/vmlinux.lz --include-cfe

## This makes modifications to the CFE which I have no way of checking are safe (without risking bricking routers!)
#echo ""
#echo "==Build bare flash image=="
#tools/createimg --boardid=$BRCM_BOARD_ID --numbermac=$BRCM_NUM_MAC_ADDRESSES --macaddr=$BRCM_BASE_MAC_ADDRESS --tp=$BRCM_MAIN_TP_NUM --psisize=$BRCM_PSI_SIZE --inputfile=$output_dir/#bcm963xx_cfe_fs_kernel --outputfile=$output_dir/flash_image

#echo ""
#echo "==Create web interface flash image (*.w)=="
#tools/addvtoken $output_dir/bcm963xx_image $output_dir/bcm963xx_image.w

echo ""
echo "Use the all images apart from fs_kernal at your own risk! The cfe included is not tested with this board!"
echo "Image creation has not been tested with this router, the tag may differ slightly"
echo "Images are created using the D-Link image builder"
echo "Done! Build scripts by mrmt32"

cp $output_dir/bcm963xx_fs_kernel /tftp/bcm963xx_fs_kernel
